import datetime
import time


class DatetimePlus(object):
    #取一个日期时间的时间部分
    @staticmethod
    def getDateTimeOnlyTime(dt):
        dtstr = DatetimePlus.datetimeToStr(dt)[12:]
        result = DatetimePlus.timestrToDateTime(dtstr)
        return result

    #取一个日期时间的日期部分
    @staticmethod
    def getDateTimeOnlyDate(dt):
        dtstr = DatetimePlus.datetimeToStr(dt)[:10]
        result = DatetimePlus.datestrToDateTime(dtstr)
        return result

    #字符串格式化成时间
    @classmethod
    def strToDateTime(cls,datetimeStr):
        result = datetime.datetime.strptime(datetimeStr, '%Y-%m-%d %H:%M:%S')
        return result

    #字符串格式化成时间
    @classmethod
    def timestrToDateTime(cls,datetimeStr):
        result = datetime.datetime.strptime(datetimeStr, '%H:%M:%S')
        return result

    #字符串格式化成时间
    @classmethod
    def datestrToDateTime(cls,datetimeStr):
        result = datetime.datetime.strptime(datetimeStr, '%Y-%m-%d')
        return result

    #取当前时间格式化成字符串用作SQL
    @classmethod
    def getNowToStr(cls):
        return time.strftime('%Y-%m-%d %H:%M:%S',time.localtime(time.time()))

    #时间格式化成字符串可以用作SQL
    @classmethod
    def datetimeToStr(cls,timeValue):
        return timeValue.strftime('%Y-%m-%d %H:%M:%S')

    #取当前日期并格式化
    @classmethod
    def getNowDateToStr(cls):
        result = time.strftime('%Y-%m-%d', time.localtime(time.time()))
        return result

    #获取当前时间的时间部分字符串
    @staticmethod
    def getNowOnlyTimeToStr():
        result = time.strftime('%H:%M:%S', time.localtime(time.time()))
        return result

    #取当前时间格式化为文件名使用
    @classmethod
    def getNowTimeToFileName(cls):
        result = time.strftime('%Y%m%d%H%M%S',time.localtime(time.time()))
        return result

    #加秒
    @classmethod
    def addSeconds(cls,sourceTime,second):
        curTime = datetime.timedelta(seconds=second)
        result = sourceTime + curTime
        return result

    #加分
    @classmethod
    def addMinutes(cls,sourceTime,minutes):
        curTime = datetime.timedelta(minutes=minutes)
        result = sourceTime + curTime
        return result

    #加天
    @classmethod
    def addDays(cls,sourceTime,days):
        curTime = datetime.timedelta(days=days)
        result = sourceTime + curTime
        return result

    #加小时
    @classmethod
    def addHours(cls,sourceTime,hours):
        curTime = datetime.timedelta(hours=hours)
        result = sourceTime + curTime
        return result
    #加周
    @classmethod
    def addWeeks(cls,sourceTime,weeks):
        curTime = datetime.timedelta(weeks=weeks)
        result = sourceTime + curTime
        return result

    #取当前时间
    @classmethod
    def getNow(cls):
        return datetime.datetime.now()

    #获取两个时间相差的秒数
    @classmethod
    def diffSeconds(cls,t1,t2):
        if t1 > t2:
            result = (t1 - t2).seconds
        else:
            result = -(t2 - t1).seconds
        return result

    #获取两个时间相差的天
    @classmethod
    def diffDays(cls,t1,t2):
        if t1 > t2:
            result = (t1 - t2).days
        else:
            result = -(t2 - t1).days
        return result

    # 获取两个时间相差的分
    @classmethod
    def diffMinutes(cls,t1,t2):
        if t1 > t2:
            result = int((t1 - t2).seconds / 60)
        else:
            result = -int((t2 - t1).seconds / 60)
        return result

    #获取两个时间相差的年
    @classmethod
    def diffYeas(cls,t1,t2):
        if t1 > t2:
            result = int((t1 - t2).days / 365)
        else:
            result = -int((t2 - t1).days / 365)
        return result

    def monthFirstDayAndLastDay(year=None, month=None):
        """
        :param year: 年份，默认是本年，可传int或str类型
        :param month: 月份，默认是本月，可传int或str类型
        :return: firstDay: 当月的第一天，datetime.date类型
                  lastDay: 当月的最后一天，datetime.date类型
        """
        if year:
            year = int(year)
        else:
            year = datetime.date.today().year

        if month:
            month = int(month)
        else:
            month = datetime.date.today().month

        import calendar
        # 获取当月第一天的星期和当月的总天数
        firstDayWeekDay, monthRange = calendar.monthrange(year, month)
        # 获取当月的第一天
        firstDay = datetime.date(year=year, month=month, day=1)
        lastDay = datetime.date(year=year, month=month, day=monthRange)
        return firstDay, lastDay

if __name__ == '__main__':
    print( DatetimePlus.getNowOnlyTimeToStr())
    t1 = datetime.datetime.now()
    t2 = DatetimePlus.addSeconds(t1, -70)

    print('diffMinutes',DatetimePlus.diffMinutes(t1, t2))
    print('diffSeconds',DatetimePlus.diffSeconds( t1,t2))
    print('diffMinutes',DatetimePlus.diffMinutes(t2, t1))
    print('diffSeconds',DatetimePlus.diffSeconds( t2,t1))
    print('t1,t2',t1, t2)
    t2 = DatetimePlus.addWeeks(t1,-70)
    print('t1,t2',t1,t2)
    print('diffYears',DatetimePlus.diffYeas(t1,t2))
    print('diffDays',DatetimePlus.diffDays(t1, t2))
    print('diffYears',DatetimePlus.diffYeas(t2,t1))
    print('diffDays',DatetimePlus.diffDays(t2, t1))
    print('now',t1)
    print('add day' , DatetimePlus.addDays(t1,1))
    print('add week' , DatetimePlus.addWeeks(t1,1))
    print('add hour' ,DatetimePlus.addHours(t1, 1))
    print('add minutes' , DatetimePlus.addMinutes(t1, 1))
    print(DatetimePlus.timestrToDateTime('21:23:59'))
    print(DatetimePlus.datestrToDateTime('2019-08-03'))

    first,last = DatetimePlus.monthFirstDayAndLastDay(2017,9)
    print(DatetimePlus.datetimeToStr(first))
    print(DatetimePlus.datetimeToStr(last))
    print('================')
    print((t1))
    print(DatetimePlus.getDateTimeOnlyDate(t1))
    print(DatetimePlus.getDateTimeOnlyTime(t1))

